%define with_tests 0

%{?_with_gstreamer: %{expand: %%global with_tests 1}}

%define libname %mklibname %{name} 0
%define libname_dev %mklibname -d %{name}
%define libname_orig lib%{name}

%define bzr	0
%define rel	8
%define major	0

%if %bzr
%define release		%mkrel -c %bzr %rel
%define distname	%name-%bzr.tar.xz
%define dir_name	%name
%define buildversion	trunk
%else
%define release		%mkrel %rel
%define distname	%name-%version.tar.bz2
%define dir_name	%name-%version
%define buildversion	%version
%endif

Name: gnash
Version: 0.8.9
Release: %{release}
Summary: %{name} - a GNU Flash movie player
License: GPLv3
Group: Networking/WWW
Source0: %{distname}
Patch0: gnash-0.8.9-ffmpeg0.8.patch
Patch1:	%{name}-0.8.3-manual.patch
Patch2: gnash-0.8.9-xulrunner-headers.patch
Patch3: gnash-0.8.9-CVE-2011-4328.diff
Patch4: gnash-0.8.10-CVE-2012-1175.diff
URL: http://www.gnu.org/software/%{name}/
BuildRequires:	kdelibs4-devel
BuildRequires:	SDL_mixer-devel
BuildRequires:	boost-devel
BuildRequires:	curl-devel
BuildRequires:	doxygen
BuildRequires:	rarian
BuildRequires:	slang-devel
BuildRequires:	libxslt-proc
BuildRequires:	agg-devel
BuildRequires:	mysql-devel
BuildRequires:	libltdl-devel
BuildRequires:	libts-devel
BuildRequires:	libgtkglext-devel
BuildRequires:	gsm-devel
BuildRequires:	nspr-devel
BuildRequires:	expat-devel
BuildRequires:	libgstreamer-plugins-base-devel
BuildRequires:	ffmpeg-devel
BuildRequires:	csound-devel
Buildrequires:	dejagnu
BuildRequires:	speex-devel
BuildRequires:	libxi-devel
BuildRequires:	desktop-file-utils
BuildRequires:	pygtk2.0-devel
BuildRequires:	xulrunner-devel
BuildRequires:	gettext-devel
BuildRequires:	libxt-devel
%if %{with_tests}
BuildRequires:	ming-devel >= 0.4.3
BuildRequires:	ming-utils >= 0.4.3
Buildrequires:	netcat
Buildrequires:	wget
%endif
Requires:	gstreamer0.10-plugins-base
Requires:	gstreamer0.10-plugins-ugly
Requires:	gstreamer0.10-plugins-bad
Requires:	gstreamer0.10-ffmpeg
Suggests:	lightspark

%description
%{name} is capable of reading up to SWF v9 files and opcodes, but primarily
supports SWF v7, with better SWF v8 and v9 support under heavy development.
With the 0.8.2 release, %{name} includes initial parser support for SWF v8
and v9. Not all ActionScript 2 classes are implemented yet, but all of
the most heavily used ones are. Many ActionScript 2 classes are partially
implemented; there is support for all of the commonly used methods of each
class.

%post -n %{name}
%_install_info %{name}.info

%preun -n %{name}
%_remove_install_info %{name}.info

%files -f %name.lang
%defattr(-,root,root,0755)
%doc README AUTHORS COPYING NEWS
%config(noreplace) %{_sysconfdir}/%{name}rc
%{_bindir}/%{name}
%{_bindir}/%{name}-gtk-launcher
%{_bindir}/fb-%{name}
%{_bindir}/gtk-%{name}
%{_bindir}/sdl-%{name}
%{_bindir}/findmicrophones
%{_bindir}/findwebcams
%{_mandir}/man1/findmicrophones.1.*
%{_mandir}/man1/findwebcams.1.*
%{_mandir}/man1/%{name}.1*
%{_mandir}/man1/fb-%{name}.1*
%{_mandir}/man1/%{name}-gtk-launcher.1*
%{_mandir}/man1/gtk-%{name}.1*
%{_mandir}/man1/sdl-%{name}.1*
%{_datadir}/%{name}
%{_datadir}/icons/hicolor/32x32/apps/%{name}.xpm
%{_datadir}/applications/%{name}.desktop

#--------------------------------------------------------------------

%package -n	%{libname}
Summary:	%{name} library
Group:	        Networking/WWW
Provides:	%{libname_orig} = %{version}

%description -n %{libname}
%{name} library.

%files -n %{libname}
%defattr(-,root,root)
%dir %{_libdir}/%{name}
%{_libdir}/%{name}/lib%{name}render-%{buildversion}.so
%{_libdir}/%{name}/lib%{name}base-%{buildversion}.so
%{_libdir}/%{name}/lib%{name}core-%{buildversion}.so
%{_libdir}/%{name}/lib%{name}amf-%{buildversion}.so
%{_libdir}/%{name}/lib%{name}media-%{buildversion}.so
%{_libdir}/%{name}/lib%{name}net-%{buildversion}.so
%{_libdir}/%{name}/lib%{name}sound-%{buildversion}.so
%{_libdir}/%{name}/lib%{name}vaapi-%{buildversion}.so

#--------------------------------------------------------------------

%package -n	%{libname_dev}
Summary:	Headers of %name for development
Group:		Development/C
Requires:	%{libname} = %{version}
Provides:	%{name}-devel = %{version}-%{release}
Provides:	%{libname_orig}-devel = %{version}-%{release}
Obsoletes: %{libname}-devel

%description -n %{libname_dev}
Headers of %{name} for development.

%files -n %{libname_dev}
%defattr(-,root,root)
%{_includedir}/%{name}/*
%{_libdir}/%{name}/lib%{name}*.la
%{_libdir}/%{name}/lib%{name}render.so
%{_libdir}/%{name}/lib%{name}amf.so
%{_libdir}/%{name}/lib%{name}base.so
%{_libdir}/%{name}/lib%{name}core.so
%{_libdir}/%{name}/lib%{name}media.so
%{_libdir}/%{name}/lib%{name}net.so
%{_libdir}/%{name}/lib%{name}sound.so
%{_libdir}/%{name}/lib%{name}vaapi.so
%{_libdir}/pkgconfig/%{name}.pc

#--------------------------------------------------------------------

%package -n %{name}-firefox-plugin
Summary:	%{name} firefox plugin
Group:		Networking/WWW
Requires:	%{name} = %{version}-%{release}

%description -n %{name}-firefox-plugin
%{name} firefox plugin

%files -n %{name}-firefox-plugin
%config(noreplace) %{_sysconfdir}/%{name}pluginrc
%{_libdir}/mozilla/plugins/*.so

#--------------------------------------------------------------------

%package -n	klash
Summary:	%{name} konqueror plugin
Group:		Graphical desktop/KDE
Requires:	%{name} = %{version}-%{release}
Obsoletes:	%{name}-konqueror-plugin
Provides:	%{name}-konqueror-plugin

%description -n klash
%{name} Konqueror plugin

%files -n klash
%{_bindir}/gnash-qt-launcher
%{_kde_bindir}/kde4-%{name}
%{_kde_libdir}/kde4/libklashpart.so
%{_kde_datadir}/kde4/services/klash_part.desktop
%{_datadir}/applications/klash.desktop
%{_datadir}/icons/hicolor/32x32/apps/klash.xpm
%{_kde_datadir}/apps/klash/
%{_mandir}/man1/kde4-%{name}.1*
%{_mandir}/man1/%{name}-qt-launcher.1*

#--------------------------------------------------------------------

%package cygnal
Summary:   Streaming media server
Requires:  %{name}-tools = %{version}-%{release}
Group:     System/Servers 

%description cygnal
Cygnal is a streaming media server that's Flash aware.

%files cygnal
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/cygnalrc
%{_bindir}/cygnal
%{_mandir}/man1/cygnal.1*
%dir %{_libdir}/cygnal
%{_libdir}/cygnal/plugins/*.so*

#--------------------------------------------------------------------

%package tools
Summary:   gnash tools
Requires:  %{name} = %{version}-%{release}
Group:     Video

%description tools
Gnash tools.

%files tools
%defattr(-,root,root,-)
%{_bindir}/gprocessor
%{_bindir}/soldumper
%{_bindir}/flvdumper
%{_bindir}/rtmpget
%{_mandir}/man1/gprocessor.1*
%{_mandir}/man1/soldumper.1*
%{_mandir}/man1/flvdumper.1*
%{_mandir}/man1/rtmpget.1*

#--------------------------------------------------------------------

%package -n python-gnash
Summary:   Gnash Python bindings
Requires:  %{name} = %{version}-%{release}
Group:     Development/Python

%description -n python-gnash
Python bindings for the Gnash widget. Can be used to embed Gnash into any PyGTK application.

%files -n python-gnash
%defattr(-,root,root,-)
%doc COPYING
%{python_sitearch}/gtk-2.0/gnash.so

#--------------------------------------------------------------------

%package extension-fileio
Summary:   Fileio extension for Gnash
Group:     Networking/WWW
Requires:  %{name} = %{version}-%{release}

%description extension-fileio
This extension allows SWF files being played within Gnash to have direct access to the file system. The API is similar to the C library one.

%files extension-fileio
%defattr(-,root,root,-)
%doc COPYING
%{_libdir}/gnash/plugins/fileio.so

#--------------------------------------------------------------------

%package extension-lirc
Summary:   LIRC extension for Gnash
Group:     Networking/WWW
Requires:  %{name} = %{version}-%{release}

%description extension-lirc
This extension allows SWF files being played within Gnash to have direct access to a LIRC based remote control device. The API is similar to the standard LIRC one.

%files extension-lirc
%defattr(-,root,root,-)
%doc COPYING
%{_libdir}/gnash/plugins/lirc.so

#--------------------------------------------------------------------

%package extension-dejagnu
Summary:   DejaGnu extension for Gnash
Group:     Development/Other
Requires:  %{name} = %{version}-%{release}

%description extension-dejagnu
This extension allows SWF files to have a simple unit testing API. The API
is similar to the DejaGnu unit testing one.

%files extension-dejagnu
%defattr(-,root,root,-)
%doc COPYING
%{_libdir}/gnash/plugins/dejagnu.so

#--------------------------------------------------------------------

%package extension-mysql
Summary:   MySQL extension for Gnash
Group:     Development/Databases
Requires:  %{name} = %{version}-%{release}

%description extension-mysql
This extension allows SWF files being played within Gnash to have direct access to a MySQL database. The API is similar to the standard MySQL one.

%files extension-mysql
%defattr(-,root,root,-)
%doc COPYING
%{_libdir}/gnash/plugins/mysql.so

#--------------------------------------------------------------------


%prep
%setup -q -n %{dir_name}
%patch0 -p0 -b .ffmpeg
%patch1 -p1 -b .manual~
%patch2 -p1 -b .xulrunner
%patch3 -p1 -b .CVE-2011-4328
%patch4 -p1 -b .CVE-2012-1175

%build
./autogen.sh
%define _disable_ld_no_undefined 0

%configure2_5x --disable-static --with-npapi-plugindir=%{_libdir}/mozilla/plugins \
  --enable-extensions=fileio,lirc,dejagnu,mysql \
  --enable-renderer=all \
  --with-plugins-install=system \
  --disable-ghelp \
  --disable-rpath \
  --enable-gui=gtk,kde4,sdl,fb \
%if %{with_tests}
  --enable-testsuite \
%else
  --disable-testsuite \
  --without-swfdec-testsuite \
%endif
  --enable-media=ffmpeg,gst \
  --enable-cygnal \
  --disable-dependency-tracking \
  --enable-python \
  --enable-doublebuf \
  --disable-jemalloc \
  --disable-docbook \
  --htmldir=%{_datadir}/gnash/html
   

%make

%if %{with_tests}
%make check
%endif

%install
rm -rf %{buildroot}
make install install-plugins \
 DESTDIR=%{buildroot} INSTALL='install -p' \
 KDE4_PLUGINDIR=%{_kde_libdir}/kde4 \
 KDE4_SERVICESDIR=%{_kde_datadir}/kde4/services \
 KDE4_CONFIGDIR=%{_kde_configdir} \
 KDE4_APPSDATADIR=%{_kde_appsdir}/klash


#menu entry
desktop-file-install					\
	--dir %{buildroot}%{_datadir}/applications	\
	%{buildroot}%{_datadir}/applications/%{name}.desktop

desktop-file-install					\
	--dir %{buildroot}%{_datadir}/applications	\
	%{buildroot}%{_datadir}/applications/klash.desktop


rm -rf %{buildroot}/%{_localstatedir}/lib/scrollkeeper
rm -f %{buildroot}/%{_libdir}/mozilla/plugins/*.a
rm -f %{buildroot}/%{_libdir}/mozilla/plugins/*.la

%find_lang %name

%clean
rm -rf %{buildroot}




%changelog

* Sat Apr 21 2012 luigiwalser <luigiwalser> 0.8.9-8.mga2
+ Revision: 232379
- revert to 0.8.9
- fix CVE-2011-4328 and CVE-2012-1175

  + fwang <fwang>
    - update file list

  + tv <tv>
    - adjust file list
    - Buildrequires:  libxt-devel
    - BuildRequires libGConf2-devel
    - new release

* Mon Nov 28 2011 fwang <fwang> 0.8.9-7.mga2
+ Revision: 173551
- fix build with latest xulrunner
- rebuild for new boost

* Wed Sep 14 2011 fwang <fwang> 0.8.9-6.mga2
+ Revision: 143185
- rebuild for new libpng
- rebuild for new boost

* Sun Jun 26 2011 fwang <fwang> 0.8.9-4.mga2
+ Revision: 114070
- more fix on ffmpeg 0.8
- add upstream patch to detect recent ffmpeg
- rebuild for new ffmpeg

* Wed Jun 22 2011 fwang <fwang> 0.8.9-3.mga2
+ Revision: 111880
- rebuild for new boost

* Thu Mar 24 2011 boklm <boklm> 0.8.9-2.mga1
+ Revision: 76272
- rebuild for bug #497

* Sat Mar 19 2011 eandry <eandry> 0.8.9-1.mga1
+ Revision: 74502
- update files list
- BR gettext-devel
- New version 0.8.9
- rename kde package to klash
- update BR
- use provided desktop files
- drop SOURCE1, included in tarball
- split extensions in their own package
- package python-gnash

* Sun Feb 20 2011 eandry <eandry> 0.8.8-5.mga1
+ Revision: 54624
- remove obsolete conditional
- rename mandriva stuff
- remove mdkversion and buildroot
- bump for upgrade
- imported package gnash

